<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AccountInfo' => '\\StructType\\AccountInfo',
            'VersionInfo' => '\\StructType\\VersionInfo',
            'data' => '\\StructType\\Data',
            'BaseResponse' => '\\StructType\\BaseResponse',
            'ModelYears' => '\\StructType\\ModelYears',
            'Divisions' => '\\StructType\\Divisions',
            'Subdivisions' => '\\StructType\\Subdivisions',
            'Models' => '\\StructType\\Models',
            'Styles' => '\\StructType\\Styles',
            'Style' => '\\StructType\\Style',
            'bodyType' => '\\StructType\\BodyType',
            'stockImage' => '\\StructType\\StockImage',
            'Price' => '\\StructType\\Price',
            'PriceRange' => '\\StructType\\PriceRange',
            'VehicleDescription' => '\\StructType\\VehicleDescription',
            'vinDescription' => '\\StructType\\VinDescription',
            'Range' => '\\StructType\\Range',
            'InstallationCause' => '\\StructType\\InstallationCause',
            'Engine' => '\\StructType\\Engine',
            'displacement' => '\\StructType\\Displacement',
            'fuelEconomy' => '\\StructType\\FuelEconomy',
            'fuelCapacity' => '\\StructType\\FuelCapacity',
            'ValueRPM' => '\\StructType\\ValueRPM',
            'Standard' => '\\StructType\\Standard',
            'OemDescription' => '\\StructType\\OemDescription',
            'CategoryAssociation' => '\\StructType\\CategoryAssociation',
            'Option' => '\\StructType\\Option',
            'OptionPrice' => '\\StructType\\OptionPrice',
            'GenericEquipment' => '\\StructType\\GenericEquipment',
            'ConsumerInformation' => '\\StructType\\ConsumerInformation',
            'item' => '\\StructType\\Item',
            'TechnicalSpecification' => '\\StructType\\TechnicalSpecification',
            'range' => '\\StructType\\Range_1',
            'value' => '\\StructType\\Value',
            'GenericColor' => '\\StructType\\GenericColor',
            'Color' => '\\StructType\\Color',
            'ResponseStatus' => '\\StructType\\ResponseStatus',
            'status' => '\\StructType\\Status',
            'MatchedEquipment' => '\\StructType\\MatchedEquipment',
            'MatchedNonFactoryEquipment' => '\\StructType\\MatchedNonFactoryEquipment',
            'IdentifiedString' => '\\StructType\\IdentifiedString',
            'DisplacementValue' => '\\StructType\\DisplacementValue',
            'CategoryDefinition' => '\\StructType\\CategoryDefinition',
            'Acode' => '\\StructType\\Acode',
            'CategoryDefinitions' => '\\StructType\\CategoryDefinitions',
            'TechnicalSpecificationDefinition' => '\\StructType\\TechnicalSpecificationDefinition',
            'TechnicalSpecificationDefinitions' => '\\StructType\\TechnicalSpecificationDefinitions',
            'MediaGallery' => '\\StructType\\MediaGallery',
            'view' => '\\StructType\\View',
            'colorized' => '\\StructType\\Colorized',
            'Image' => '\\StructType\\Image',
            'BaseRequest' => '\\StructType\\BaseRequest',
            'DivisionsRequest' => '\\StructType\\DivisionsRequest',
            'SubdivisionsRequest' => '\\StructType\\SubdivisionsRequest',
            'ModelsRequest' => '\\StructType\\ModelsRequest',
            'StylesRequest' => '\\StructType\\StylesRequest',
            'VehicleDescriptionRequest' => '\\StructType\\VehicleDescriptionRequest',
        );
    }
}
