<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CategoryDefinition StructType
 * @subpackage Structs
 */
class CategoryDefinition extends AbstractStructBase
{
    /**
     * The group
     * @var \StructType\IdentifiedString
     */
    public $group;
    /**
     * The header
     * @var \StructType\IdentifiedString
     */
    public $header;
    /**
     * The category
     * @var \StructType\IdentifiedString
     */
    public $category;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\IdentifiedString
     */
    public $type;
    /**
     * Constructor method for CategoryDefinition
     * @uses CategoryDefinition::setGroup()
     * @uses CategoryDefinition::setHeader()
     * @uses CategoryDefinition::setCategory()
     * @uses CategoryDefinition::setType()
     * @param \StructType\IdentifiedString $group
     * @param \StructType\IdentifiedString $header
     * @param \StructType\IdentifiedString $category
     * @param \StructType\IdentifiedString $type
     */
    public function __construct(\StructType\IdentifiedString $group = null, \StructType\IdentifiedString $header = null, \StructType\IdentifiedString $category = null, \StructType\IdentifiedString $type = null)
    {
        $this
            ->setGroup($group)
            ->setHeader($header)
            ->setCategory($category)
            ->setType($type);
    }
    /**
     * Get group value
     * @return \StructType\IdentifiedString|null
     */
    public function getGroup()
    {
        return $this->group;
    }
    /**
     * Set group value
     * @param \StructType\IdentifiedString $group
     * @return \StructType\CategoryDefinition
     */
    public function setGroup(\StructType\IdentifiedString $group = null)
    {
        $this->group = $group;
        return $this;
    }
    /**
     * Get header value
     * @return \StructType\IdentifiedString|null
     */
    public function getHeader()
    {
        return $this->header;
    }
    /**
     * Set header value
     * @param \StructType\IdentifiedString $header
     * @return \StructType\CategoryDefinition
     */
    public function setHeader(\StructType\IdentifiedString $header = null)
    {
        $this->header = $header;
        return $this;
    }
    /**
     * Get category value
     * @return \StructType\IdentifiedString|null
     */
    public function getCategory()
    {
        return $this->category;
    }
    /**
     * Set category value
     * @param \StructType\IdentifiedString $category
     * @return \StructType\CategoryDefinition
     */
    public function setCategory(\StructType\IdentifiedString $category = null)
    {
        $this->category = $category;
        return $this;
    }
    /**
     * Get type value
     * @return \StructType\IdentifiedString|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param \StructType\IdentifiedString $type
     * @return \StructType\CategoryDefinition
     */
    public function setType(\StructType\IdentifiedString $type = null)
    {
        $this->type = $type;
        return $this;
    }
}
