<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for fuelEconomy StructType
 * @subpackage Structs
 */
class FuelEconomy extends AbstractStructBase
{
    /**
     * The unit
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $unit;
    /**
     * The city
     * @var \StructType\Range
     */
    public $city;
    /**
     * The hwy
     * @var \StructType\Range
     */
    public $hwy;
    /**
     * Constructor method for fuelEconomy
     * @uses FuelEconomy::setUnit()
     * @uses FuelEconomy::setCity()
     * @uses FuelEconomy::setHwy()
     * @param string $unit
     * @param \StructType\Range $city
     * @param \StructType\Range $hwy
     */
    public function __construct($unit = null, \StructType\Range $city = null, \StructType\Range $hwy = null)
    {
        $this
            ->setUnit($unit)
            ->setCity($city)
            ->setHwy($hwy);
    }
    /**
     * Get unit value
     * @return string
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @param string $unit
     * @return \StructType\FuelEconomy
     */
    public function setUnit($unit = null)
    {
        // validation for constraint: string
        if (!is_null($unit) && !is_string($unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unit, true), gettype($unit)), __LINE__);
        }
        $this->unit = $unit;
        return $this;
    }
    /**
     * Get city value
     * @return \StructType\Range|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param \StructType\Range $city
     * @return \StructType\FuelEconomy
     */
    public function setCity(\StructType\Range $city = null)
    {
        $this->city = $city;
        return $this;
    }
    /**
     * Get hwy value
     * @return \StructType\Range|null
     */
    public function getHwy()
    {
        return $this->hwy;
    }
    /**
     * Set hwy value
     * @param \StructType\Range $hwy
     * @return \StructType\FuelEconomy
     */
    public function setHwy(\StructType\Range $hwy = null)
    {
        $this->hwy = $hwy;
        return $this;
    }
}
