<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for stockImage StructType
 * @subpackage Structs
 */
class StockImage extends Image
{
    /**
     * The filename
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $filename;
    /**
     * Constructor method for stockImage
     * @uses StockImage::setFilename()
     * @param string $filename
     */
    public function __construct($filename = null)
    {
        $this
            ->setFilename($filename);
    }
    /**
     * Get filename value
     * @return string
     */
    public function getFilename()
    {
        return $this->filename;
    }
    /**
     * Set filename value
     * @param string $filename
     * @return \StructType\StockImage
     */
    public function setFilename($filename = null)
    {
        // validation for constraint: string
        if (!is_null($filename) && !is_string($filename)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($filename, true), gettype($filename)), __LINE__);
        }
        $this->filename = $filename;
        return $this;
    }
}
