<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VersionInfo StructType
 * @subpackage Structs
 */
class VersionInfo extends BaseResponse
{
    /**
     * The data
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \StructType\Data[]
     */
    public $data;
    /**
     * Constructor method for VersionInfo
     * @uses VersionInfo::setData()
     * @param \StructType\Data[] $data
     */
    public function __construct(array $data = array())
    {
        $this
            ->setData($data);
    }
    /**
     * Get data value
     * @return \StructType\Data[]|null
     */
    public function getData()
    {
        return $this->data;
    }
    /**
     * This method is responsible for validating the values passed to the setData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDataForArrayConstraintsFromSetData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $versionInfoDataItem) {
            // validation for constraint: itemType
            if (!$versionInfoDataItem instanceof \StructType\Data) {
                $invalidValues[] = is_object($versionInfoDataItem) ? get_class($versionInfoDataItem) : sprintf('%s(%s)', gettype($versionInfoDataItem), var_export($versionInfoDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The data property can only contain items of type \StructType\Data, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set data value
     * @throws \InvalidArgumentException
     * @param \StructType\Data[] $data
     * @return \StructType\VersionInfo
     */
    public function setData(array $data = array())
    {
        // validation for constraint: array
        if ('' !== ($dataArrayErrorMessage = self::validateDataForArrayConstraintsFromSetData($data))) {
            throw new \InvalidArgumentException($dataArrayErrorMessage, __LINE__);
        }
        $this->data = $data;
        return $this;
    }
    /**
     * Add item to data value
     * @throws \InvalidArgumentException
     * @param \StructType\Data $item
     * @return \StructType\VersionInfo
     */
    public function addToData(\StructType\Data $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Data) {
            throw new \InvalidArgumentException(sprintf('The data property can only contain items of type \StructType\Data, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->data[] = $item;
        return $this;
    }
}
